; Modul: CRS_TEST.ASM

; Version 1.00          BIA - Referat 5.2                    Datum: 15.09.2000

; Funktion:
; Die Unterprogramme testen Clear-, Complement-, Rotate- und Swap-Befehle.

; Eingabeparameter: keine
; Ausgabeparameter: keine
; Vernderte Register: siehe Einzelfunktionen
; Vernderte Speicherbereiche: keine

; Fehleraussprung: nach Funktion ERROR

; bergeordnete Module: LOGITEST.ASM
; Untergeordnete Module: keine
; aufgerufen von: C_R_S_TEST
; ruft auf: -

; Stacktiefe: 2 Bytes
; Verwendete Registerbank: aktuelle Bank
; ***************************************************************************



; ********************* CLR_TEST 1 ******************************************
; Funktion: Test von CLR A 
; Vernderte Register: A, PSW
; ***************************************************************************
CLR_TEST1:      MOV     A,#0FFh                 ; Testmuster 1 laden
		CLR     A                       ; Befehlstest 
		CJNE    A,#00h,CLR_err1         ; Vergleich mit Erwartungshaltung
		RET
CLR_err1:       LJMP    ERROR_CRS



; ********************* CPL_TEST 1 ******************************************
; Funktion: Test von CPL A
; Vernderte Register: A, PSW
; ***************************************************************************
CPL_TEST1:      MOV     A,#0AAh                 ; Testmuster 1 laden
		CPL     A                       ; Befehlstest 
		CJNE    A,#55h,CPL_err1         ; Vergleich mit Erwartungshaltung
		RET
CPL_err1:       LJMP    ERROR_CRS



; ********************* RL_TEST 1 *******************************************
; Funktion: Test von RL A
; Vernderte Register: A, PSW
; ***************************************************************************
RL_TEST1:       MOV     A,#0AAh                 ; Testmuster 1 laden
		RL      A                       ; Befehlstest 
		CJNE    A,#55h,RL_err1          ; Vergleich mit Erwartungshaltung
		RET
RL_err1:        LJMP    ERROR_CRS               



; ********************* RLC_TEST 1 ******************************************
; Funktion: Test von RLC A
; Vernderte Register: A, PSW
; ***************************************************************************
RLC_TEST1:      MOV     A,#0AAh                 ; Testmuster 1 laden
		RLC     A                       ; Befehlstest 
		CJNE    A,#54h,RLC_err1         ; Vergleich mit Erwartungshaltung
		RET
RLC_err1:       LJMP    ERROR_CRS



; ********************* RR_TEST 1 *******************************************
; Funktion: Test von RR A
; Vernderte Register: A, PSW
; ***************************************************************************
RR_TEST1:       MOV     A,#0AAh                 ; Testmuster 1 laden
		RR      A                       ; Befehlstest 
		CJNE    A,#55h,RR_err1          ; Vergleich mit Erwartungshaltung
		RET
RR_err1:        LJMP    ERROR_CRS               



; ********************* RRC_TEST 1 ******************************************
;Funktion: Test von RRC A
;Vernderte Register: A, PSW
; ***************************************************************************
RRC_TEST1:      MOV     A,#55h                  ; Testmuster 1 laden
		RRC     A                       ; Befehlstest 
		CJNE    A,#2Ah,RRC_err1         ; Vergleich mit Erwartungshaltung
		RET
RRC_err1:       LJMP    ERROR_CRS               



; ********************* SWAP_TEST 1 *****************************************
; Funktion: Test von SWAP A
; Vernderte Register: A, PSW
; ***************************************************************************
SWAP_TEST1:     MOV     A,#0C3h                 ; Testmuster 1 laden
		SWAP    A                       ; Befehlstest
		CJNE    A,#3Ch,SWAP_err1        ; Vergleich mit Erwartungshaltung 
		RET 
SWAP_err1:      LJMP    ERROR_CRS       



; ***************************************************************************
ERROR_CRS:      MOV     FEHLER,#FEHLER_CRS      ; Fehlerspeicher laden
		LJMP    ERROR
; ***************************************************************************
